#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main()
{
    ios::sync_with_stdio(false);
    ll R, C;
    cin >> R >> C;
    auto dist = [=](ll i, ll j)
    {
        return llabs(R - 1 - 2 * i) + llabs(C - 1 - 2 * j);
    };
    ll bestp = -1;
    ll besti = -1, bestj = -1;
    ll bestd = INT_MAX;
    ll bestr = 0;
    for (ll p = 0; p < C; p++)
    {
        ll minr = 0;
        ll maxr = R - 1;
        ll minc = 0;
        ll maxc = C - 1;
        ll rounds = 0;
        while (true)
        {
            ll minpos = p * R + minr;
            ll maxpos = p * R + maxr;
            ll minr2 = minpos / C;
            ll maxr2 = maxpos / C;
            ll minc2 = minpos % C;
            ll maxc2 = maxpos % C;
            if (minr2 == minr && maxr2 == maxr && minc2 == minc && maxc2 == maxc)
                break;
            rounds++;
            minr = minr2;
            maxr = maxr2;
            minc = minc2;
            maxc = maxc2;
        }
        if (minr != maxr || minc != maxc)
            continue;

        if (dist(minr, minc) < bestd)
        {
            bestp = p;
            besti = minr;
            bestj = minc;
            bestd = dist(minr, minc);
            bestr = rounds;
        }
    }
    cout << bestp + 1 << ' ' << besti + 1 << ' ' << bestj + 1 << ' ' << bestr << '\n';
}
