#!/usr/bin/python3
(r, c) = map(int, input().split())

def step(i, j, p):
    x = (p-1)*r + i - 1
    return (1 + x//c, 1 + x%c)

def iterstep(i, j, p):
    s = 0
    while True:
        (ni, nj) = step(i, j, p)
        if (ni, nj) == (i, j): return (i, j, s)
        (i, j) = (ni, nj)
        s += 1

min_dist = 1e30
for p_cand in range(1, c+1):
    (i, j, _) = iterstep(1, 1, p_cand)
    (oi, oj, _) = iterstep(r, 1, p_cand)
    if (oi, oj) != (i, j): continue
    # dist = min(abs(i - (r+2)//2), abs(i - (r+1)//2)) + min(abs(j - (c+2)//2), abs(j - (c+1)//2))
    dist = min(abs(i - (r+2)//2) + min(abs(j - (c+2)//2),
                                       abs(j - (c+1)//2)),
               min(abs(i - (r+2)//2),
                   abs(i - (r+1)//2)) + abs(j - (c+2)//2))
    if dist < min_dist:
        min_dist = dist
        p = p_cand

max_s = 0
for i in range(r):
    (_, _, s) = iterstep(r, 1, p)
    max_s = max(s, max_s)
        
(i, j, _) = iterstep(1, 1, p)

print(p, i, j, s)

