import java.util.*;
import java.io.*;

public final class bmerry
{
    public static void main(String[] args) throws IOException
    {
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        String S = in.readLine();
        int N = S.length();

        int[] rad = new int[N + 1];
        @SuppressWarnings("unchecked")
        ArrayList<Integer>[] foldr = new ArrayList[N + 1];
        @SuppressWarnings("unchecked")
        ArrayList<Integer>[] foldl = new ArrayList[N + 1];
        for (int i = 0; i <= N; i++)
        {
            foldl[i] = new ArrayList<Integer>();
            foldr[i] = new ArrayList<Integer>();
        }
        int far = 0;
        for (int i = 1; i <= N; i++)
        {
            int r = 0;
            if (i < far + rad[far])
                r = Math.min(rad[2 * far - i], far + rad[far] - i);
            while (r < i && i + r < N && S.charAt(i - r - 1) == S.charAt(i + r))
                r++;
            rad[i] = r;
            assert(i + r <= N);
            if (i + r > far + rad[far])
                far = i;

            foldl[i - r].add(i);
            foldr[i + r].add(i);
        }

        int L = 0;
        int R = N;
        while (true)
        {
            int oldL = L;
            int oldR = R;

            int dL = L;
            while (dL <= L)
            {
                for (int v : foldl[dL])
                    if (2 * v <= L + R)
                        L = Math.max(L, v);
                dL++;
            }
            int dR = R;
            while (dR >= R)
            {
                for (int v : foldr[dR])
                    if (2 * v >= L + R)
                        R = Math.min(R, v);
                dR--;
            }
            if (oldL == L && oldR == R)
                break;
        }
        System.out.println(R - L);
    }
}
