
fun foldable(T: List<Int>) : BooleanArray {
    val A = BooleanArray(T.count() - 1)
    A[0] = true
    var best = 0
    for (i in 1 until T.count()) {
        if (best >= i - T[i]) { best = i; A[i] = true }
    }
    return A
}

fun solve(S: String) : Int {
    val N = S.count()
    val L = mutableListOf(0, 1)
    var C = 1
    for (i in 2..2*N) {
        var l = Math.min(L[2*C-i], Math.max(0, L[C]+C-i))
        while (i - l > 0 && i + l < 2*N && ((i+l)%2 == 1 || S[(i-l-1)/2] == S[(i+l+1)/2])) ++l
        L.add(l)
        C = listOf(i,C).maxByOrNull { it + L[it] }!!
    }

    val T = L.filterIndexed { i, _ -> i % 2 == 0 }.map{ it / 2 }
    val A = foldable(T)
    val B = foldable(T.reversed()).reversed()
    var j = 0
    var ans = N
    for (i in 0 until N) {
        if (A[i]) {
            j = Math.max(j, i)
            while (!B[j]) ++j;
            ans = Math.min(ans, j-i+1)
        }
    }
    return ans
}

fun main(args: Array<String>) {
    println(solve(readLine()!!.trim()))
//    println(solve("ATTAGG"))
//    println(solve("AAAAGAATTAA"))
}
