#include <bits/stdc++.h>

typedef unsigned long long ull;
const int B = 257;


char S[1<<22], Srev[1<<22];

int main(void) {
    scanf("%s", S);
    int N = strlen(S);
    for (int i = 0; i < N; ++i)
        Srev[N-1-i] = S[i];
    
    ull FHash[N+1] = {};
    ull BHash[N+1] = {};
    ull BPow[N+1] = {1};
    for (int i = 0; i < N; ++i) {
        FHash[i+1] = FHash[i] * B + S[i];
        BPow[i+1] = BPow[i] * B;
    }
    for (int i = N-1; i >= 0; --i) {
        BHash[i] = BHash[i+1]*B + S[i];
    }

    auto is_palin = [&](int l, int r) -> bool {
        bool hash_eq = (FHash[r] - BPow[r-l]*FHash[l]) == (BHash[l] - BPow[r-l]*BHash[r]);
        if (!hash_eq) return false;
        return memcmp(S + l, Srev + (N-r), (r-l)/2) == 0;
    };

    int l = 0, r = N, i = 1;
    while (i <= (r-l)/2) {
        if (is_palin(l, l+2*i)) {
            l += i;
            i = 1;
        } else if (is_palin(r-2*i, r)) {
            r -= i;
            i = 1;
        } else {
            ++i;
        }
    }
    printf("%d\n", r-l);
}
