#!/usr/bin/env python3

S = input()
S = [S[i//2] if i % 2 == 0 else '.' for i in range(2*len(S)-1)]
n = len(S)

max_pal = [1]*n
cur_m = cur_r = 0
for m in range(n):
    if m >= cur_r:
        cur_m = m
        cur_r = m+1
    else:
        max_pal[m] = min(cur_r - m, max_pal[2*cur_m - m])
    if m + max_pal[m] == cur_r:
        while 2*m-cur_r >= 0 and cur_r < n and S[cur_r] == S[2*m-cur_r]:
            max_pal[m] += 1
            cur_m = m
            cur_r += 1

l = 0
r = n
i = 1
while i <= (r-l)//2:
    if max_pal[l+i] > i:
        l += i+1
        i = 1
    elif max_pal[r-1-i] > i:
        r -= i+1
        i = 1
    else:
        i += 2

print((r-l+1)//2)

