#pragma GCC optimize("O3")
#pragma GCC target("arch=corei7-avx")
#include <cstdio>
#include <cstring>

char S[1<<22];

int main(void) {
    scanf("%s", S);
    int N = strlen(S);

    auto is_palin = [&](int l, int r) -> bool {
        int m = l + (r-l)/2;
        for (int i = 0; ; ++i) {
            if (S[l+i] != S[r-1-i])
                return false;
            if (S[m-1-i] != S[m+i])
                return false;
            if (l+i+1 >= m-i-1) break;
        }
        return true;
    };

    int l = 0, r = N, i = 1;
    while (i <= (r-l)/2) {
        if (is_palin(l, l+2*i)) {
            l += i;
            i = 1;
        } else if (is_palin(r-2*i, r)) {
            r -= i;
            i = 1;
        } else {
            ++i;
        }
    }
    printf("%d\n", r-l);
}
