#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vll = vector<ll>;

int main()
{
    ios::sync_with_stdio(false);
    int N, K;
    cin >> N >> K;
    vll lin(N + 1), cst(N + 1);
    auto update = [&](int u, int v, ll l, ll c)
    {
        lin[u] += l;
        lin[v] -= l;
        cst[u] += c;
        cst[v] -= c;
    };
    for (int i = 0; i < K; i++)
    {
        char t;
        int u, v;
        cin >> t >> u >> v;
        u--;
        switch (t)
        {
        case 'R':
            update(u, v, 0, 1);
            break;
        case 'D':
            update(u, v, 0, -1);
            break;
        default:
            int sgn = (t == 'H') ? 1 : -1;
            int mid = (u + v) / 2;
            update(u, mid, sgn, -sgn * (u - 1));
            update(mid, v, -sgn, sgn * v);
        }
    }

    ll L = 0;
    ll C = 0;
    for (int i = 0; i < N; i++)
    {
        L += lin[i];
        C += cst[i];
        cout << L * i + C << '\n';
    }
    return 0;
}
