#include <cstdio>

#define MX 200100

typedef long long ll;

// delta[i] is applied to value[i]
int deltas[MX];
// accdelta[i] is applied to delta[i] before it's applied to value[i]
int accdeltas[MX];

int N, K;

int main() {
  scanf("%d %d\n", &N, &K);
  for (int i = 0; i < N; ++i) deltas[i] = accdeltas[i] = 0;
  for (int i = 0; i < K; ++i) {
    int x1, x2;
    char c;
    scanf("%c %d %d\n", &c, &x1, &x2);
    int delta = 1;
    if (c == 'D') {
      c = 'R';
      delta = -1;
    }
    if (c == 'V') {
      c = 'H';
      delta = -1;
    }
    if (c == 'R') {
      deltas[x1-1] += delta;
      deltas[x2] -= delta;
    }
    if (c == 'H') {
      accdeltas[x1-1] += delta;
      accdeltas[x2+1] += delta;
      accdeltas[(x1+x2)/2] -= delta;
      accdeltas[(x1+x2+1)/2] -= delta;
    }
  }
  int cacc = 0;
  ll cval = 0;
  for (int i = 0; i < N; ++i) {
    cacc += accdeltas[i];
    deltas[i] += cacc;
    cval += deltas[i];
    printf("%lld\n", cval);
  }
}
