import java.util.*;
import java.io.*;

public class RSRNaiveLandscape {
  public static long l[];
  public static int n,k;

  public static void main(String[] args) throws IOException {
    BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
    StringTokenizer st = new StringTokenizer(in.readLine());
    n = Integer.parseInt(st.nextToken());
    k = Integer.parseInt(st.nextToken());
    l = new long[n];
    for (int i = 0; i < k; i++) {
      st = new StringTokenizer(in.readLine());
      String c = st.nextToken();
      int x1 = Integer.parseInt(st.nextToken()) - 1;
      int x2 = Integer.parseInt(st.nextToken()) - 1;
      if (c.equals("H")) {
        int inc = 0;
        int lim = (x2-x1)/2;
        for (int j = 0; j < lim; j++) {
          inc += 1;
          l[x1+j] += inc;
          l[x2-j] += inc;
        }
        l[x1+lim] += inc+1;
        if ((x2-x1)%2 == 1)
          l[x2-lim] += inc+1;
      } else if (c.equals("V")) {
        int inc = 0;
        int lim = (x2-x1)/2;
        for (int j = 0; j < lim; j++) {
          inc += 1;
          l[x1+j] -= inc;
          l[x2-j] -= inc;
        }
        l[x1+lim] -= inc+1;
        if ((x2-x1)%2 == 1)
          l[x2-lim] -= inc+1;
      } else if (c.equals("R")) {
        for (int j = x1; j <= x2; j++) {
          l[j] += 1;
        }
      } else if (c.equals("D")) {
        for (int j = x1; j <= x2; j++) {
          l[j] -= 1;
        }
      }
    }
    for (int i = 0; i < n; i++) {
      System.out.println(l[i]);
    }
  }
}
