import java.util.*;
import java.io.*;

public class RSRNoLongInt {
  public static int h[]; // adjust for R and D
  public static int d[]; // adjust for H and V
  public static int n,k;

  public static void main(String[] args) throws IOException {
    BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
    StringTokenizer st = new StringTokenizer(in.readLine());
    n = Integer.parseInt(st.nextToken());
    k = Integer.parseInt(st.nextToken());
    h = new int[n+1];
    d = new int[n+2];
    for (int i = 0; i < k; i++) {
      st = new StringTokenizer(in.readLine());
      char c = st.nextToken().charAt(0);
      int x1 = Integer.parseInt(st.nextToken()) - 1;
      int x2 = Integer.parseInt(st.nextToken()) - 1;
      switch (c) {
        case 'R':
          h[x1] += 1; h[x2+1] -= 1;
          break;
        case 'D':
          h[x1] -= 1; h[x2+1] += 1;
          break;
        case 'H':
          d[x1] += 1;
          if (x2==x1+1) {
            d[x2] -= 1;
            d[x2+1] -= 1;
            d[x2+2] += 1;
            break;
          }
          else if ((x2-x1)%2 == 1) { // odd case
            d[1+(x1+x2)/2] -= 1;
            d[2+(x1+x2)/2] -= 1;
          } else { // even case
            d[1+(x1+x2)/2] -= 2;
          }
          d[x2+2] += 1;
          break;
        case 'V':
          d[x1] -= 1;
          if (x2==x1+1) {
            d[x2] += 1;
            d[x2+1] += 1;
            d[x2+2] -= 1;
            break;
          }
          else if ((x2-x1)%2 == 1) { // odd case
            d[1+(x1+x2)/2] += 1;
            d[2+(x1+x2)/2] += 1;
          } else {
            d[1+(x1+x2)/2] += 2;
          }
          d[x2+2] -= 1;
          break;
      }
    }
    int sum = 0;
    int inc = 0;
    int dh = 0;
    for (int i = 0; i < n; i++) {
      sum += h[i];
      inc += d[i];
      dh += inc;
      System.out.println(sum+dh);
    }
  }
}
