#!/usr/bin/env python3

import argparse
import random


parser = argparse.ArgumentParser()
parser.add_argument('N', type=int)
parser.add_argument('T', type=int)
parser.add_argument('-x', type=int, default=10**9, help='x range')
parser.add_argument('-y', type=int, default=10**9, help='y range')
args = parser.parse_args()
N = args.N

print(N, args.T)
seen = set()
for i in range(N):
    while True:
        x = random.randint(-args.x, args.x)
        y = random.randint(-args.y, args.y)
        if (x, y) not in seen:
            break
    seen.add((x, y))
    print(x, y)
