#include <bits/stdc++.h>
using namespace std;
#include "common.h"

int main(int argc, char **argv) {
    int n = atoi(argv[1]);
    int ans_target = atoi(argv[2]);
    int target_offs = atoi(argv[3]);
    assert(2 <= ans_target && ans_target <= n);
    int max_x = atoi(argv[4]);
    int max_y = atoi(argv[5]);
    int seed = atoi(argv[6]);
    srandom(seed);
    vector<point> P(n);
    while (true) {
        for (auto &p: P) {
            p.x = -max_x + random() % (2*max_x+1);
            p.y = -max_y + random() % (2*max_y+1);
        }
        Z t_lo = 1, t_hi = 1;
        if (solve(P, t_lo) >= ans_target) continue;
        while (solve(P, t_hi) < ans_target) {
            t_lo = t_hi;
            t_hi *= 2;
        }

        while (t_hi - t_lo > 1) {
            Z t = (t_lo + t_hi)/2;
            if (solve(P, t) >= ans_target)
                t_hi = t;
            else
                t_lo = t;
        }
        Z t = t_hi-target_offs;
        if (!is_valid(P, t)) continue;
        
        printf("%d %d\n", n, t);
        for (auto &p: P)
            printf("%lld %lld\n", p.x, p.y);
        break;
    }
    return 0;
}
