#include <cstdio>

#define MAXN 200000
#define MAXX ((unsigned int)(1e9))

unsigned int val[MAXN][8];
int N;
unsigned int bnd[8];

int main() {
  for (int mask = 0; mask < 8; ++mask) bnd[mask] = 0;
  scanf("%d", &N);
  for (int i = 0; i < N; ++i) {
    int x[3];
    scanf("%d %d %d", &x[0], &x[1], &x[2]);
    for (int mask = 1; mask < 8; ++mask) {
      val[i][mask] = 0;
      for (int pos = 0; pos < 3; ++pos) {
        if ((1 << pos) & mask) {
          val[i][mask] += x[pos];
        }
      }
      if (val[i][mask] > bnd[mask]) bnd[mask] = val[i][mask];
    }
  }
  unsigned int bestdist = 3 * MAXX;
  int bind = 0;
  for (int i = 0; i < N; ++i) {
    unsigned int dist = 0;
    for (int mask = 1; mask < 8; ++mask) {
      if (bnd[mask] - val[i][mask] > dist) {
        dist = bnd[mask] - val[i][mask];
      }
    }
    if (bestdist > dist) {
      bestdist = dist;
      bind = i;
    }
  }
  printf("%u %d\n", bestdist, bind + 1);
}
