#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int N;
    cin >> N;

    vector<int> x(N), y(N), z(N);
    for (int i = 0; i < N; i++)
        cin >> x[i] >> y[i] >> z[i];

    uint best = UINT_MAX;
    int bestp = -1;
    for (int i = 0; i < N; i++)
    {
        uint cur = 0;
        for (int j = 0; j < N; j++)
        {
            uint score = uint(max(x[j] - x[i], 0))
                + uint(max(y[j] - y[i], 0))
                + uint(max(z[j] - z[i], 0));
            cur = max(cur, score);
        }
        if (cur < best)
        {
            best = cur;
            bestp = i;
        }
    }
    cout << best << ' ' << bestp + 1 << '\n';
    return 0;
}
