#!/usr/bin/env python3

import argparse
import random

from utils import print_case, SCALE

parser = argparse.ArgumentParser()
parser.add_argument('N', type=int)
args = parser.parse_args()
N = args.N
if 360 * SCALE % N:
    parser.error('N must divide into {}'.format(360 * SCALE))

random.seed(234562375 * N)

ratio = 360 * SCALE // N
shift = 180 * SCALE - N * ratio // 2
coords1 = [(10, i * ratio + shift) for i in range(N)]
coords2 = list(coords1)
coords2[-1] = (10, coords2[-1][1] + 1)
print_case(coords1, coords2)
