import random

SCALE = 10000

def print_coords(coords):
    coords = list(coords)
    random.shuffle(coords)
    for x, y in coords:
        y = y % (360 * SCALE)
        if y > 180 * SCALE:
            y -= 360 * SCALE
        print('{:.4f} {:.4f}'.format(x / SCALE, y / SCALE))

def print_case(coords1, coords2):
    N = len(coords1)
    assert len(coords2) == N
    print(N)
    print_coords(coords1)
    print_coords(coords2)

def print_same_case(coords1, rot):
    coords2 = [(lat, lon + rot) for lat, lon in coords1]
    print_case(coords1, coords2)
