#include <bits/stdc++.h>

using namespace std;

using level = pair<int, int>;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, v, c;
    cin >> n >> v >> c;

    int tot = 0;
    // exp, target level
    vector<level> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;

        tot += a[i].first;
    }

    // sort by deadlines - max exp you can have _after_ completion
    sort(begin(a), end(a), [&](const level& x, const level& y) {
        return (c * x.first + v * x.second) < (c * y.first + v * y.second);
    });

    vector<char> dp(tot + 1, false);
    dp[0] = true;
    for (level& lvl : a) {
        for (int j = tot - lvl.first; j >= 0; --j) {
            if (c * j < v * lvl.second)
                dp[j + lvl.first] |= dp[j];
        }
    }

    int ans = tot;
    while (!dp[ans])
        --ans;

    ans = tot + (c - 1) * ans;

    cout << ans << '\n';

    return 0;
}
