#include <bits/stdc++.h>

using namespace std;

using level = pair<int, int>;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, v, c;
    cin >> n >> v >> c;

    int tot = 0;
    // exp, target level
    vector<level> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;

        tot += a[i].first;
    }

    // sort by deadlines - max exp you can have _after_ completion
    sort(begin(a), end(a), [&](const level& x, const level& y) {
        return (c * x.first + v * x.second) < (c * y.first + v * y.second);
    });

    vector<int> dp = {0};
    for (level& lvl : a) {
        vector<int> fointow;
        for (int x : dp) {
            if (c * x < v * lvl.second) {
                fointow.push_back(x + lvl.first);
            } else {
                break;
            }
        }

        // do the merge sort on v and nv
        sort(begin(fointow), end(fointow));

        vector<int> new_dp;
        int i = 0;
        int j = 0;
        while (i < dp.size() and j < fointow.size()) {
            if (dp[i] < fointow[j]) {
                if (!new_dp.empty() and new_dp.back() == dp[i]) {
                    ++i;
                } else {
                    new_dp.push_back(dp[i++]);
                }
            } else {
                if (!new_dp.empty() and new_dp.back() == fointow[j]) {
                    ++j;
                } else {
                    new_dp.push_back(fointow[j++]);
                }
            }
        }

        while (i < dp.size()) {
            if (!new_dp.empty() and new_dp.back() == dp[i])
                ++i;
            else
                new_dp.push_back(dp[i++]);
        }

        while (j < fointow.size()) {
            if (!new_dp.empty() and new_dp.back() == fointow[j])
                ++j;
            else
                new_dp.push_back(fointow[j++]);
        }

        swap(dp, new_dp);
    }

    int ans = dp.back();
    ans = tot + (c - 1) * ans;

    cout << ans << '\n';

    return 0;
}
