#include <bits/stdc++.h>

using namespace std;

using level = pair<int, int>;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, v, c;
    cin >> n >> v >> c;

    int tot = 0;
    // exp, target level
    vector<level> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;

        tot += a[i].first;
    }

    // sort by deadlines - max exp you can have _after_ completion
    sort(begin(a), end(a), [&](const level& x, const level& y) {
        return (c * x.first + v * x.second) < (c * y.first + v * y.second);
    });

    set<int> dp = {0};
    for (level& lvl : a) {
        cerr << dp.size() << endl;
        set<int> new_dp;
        for (int x : dp) {
            if (c * x < v * lvl.second) {
                new_dp.insert(x + lvl.first);
            } else {
                break;
            }
        }

        for (int x : new_dp) {
            dp.insert(x);
        }
    }

    int ans = *prev(end(dp));
    ans = tot + (c - 1) * ans;

    cout << ans << '\n';

    return 0;
}
