//Checks that the graph forms a tree.

//It does not check the formatting - bmerry.ctd does that.

import java.util.*;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class bmerry_tree {

  public static void main(String[] args) throws IOException  {
    BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
    int N = Integer.parseInt(in.readLine());
    ArrayList[] edges = new ArrayList[N];
    for (int i =0; i < N; i++) {
       edges[i] = new ArrayList<Integer>();
    }
    for (int i = 0; i < N-1; i++) {
      StringTokenizer st = new StringTokenizer(in.readLine());
      int a = Integer.parseInt(st.nextToken())-1;
      int b = Integer.parseInt(st.nextToken())-1;
      int d = Integer.parseInt(st.nextToken());
      edges[a].add(b);
      edges[b].add(a);
    }
    boolean seen[] = new boolean[N];
    int c = dfs(0,edges,seen);
    if (c != N) {
      System.out.println("Not a tree (vertex 1 is part of component of size "
           +c+")");
      System.exit(1);
    }
    System.exit(42);
  }

  public static int dfs(int cur, ArrayList[] edges, boolean[] seen) {
    if (seen[cur]) {
        return 0;
    }
    seen[cur] = true;
    int ans = 1;
    for (Integer y : (ArrayList<Integer>)edges[cur]) {
        ans += dfs(y, edges, seen);
    }
    return ans;
  }
}
