#!/usr/bin/env python3

# Star topology, each leaf then connected to two further children

import argparse
from random import *

from speedlimit_utils import MAXS, output

parser = argparse.ArgumentParser()
parser.add_argument('n', type=int)
parser.add_argument('c', type=int)
args = parser.parse_args()
n = args.n
m = (n - 1) // 3
edges = []
for i in range(m):
    edges.append((n - 1, i, randint(1, MAXS)))
for i in range(m, n - 1):
    edges.append((i, i % m, randint(1, MAXS)))
output(edges, args.c)
