import java.io.*;
import java.util.*;
import java.math.*;

public class TrailingDigitsBigInt {
    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer st = new StringTokenizer(br.readLine());
        BigInteger b = new BigInteger(st.nextToken());
        char d = st.nextToken().charAt(0);
        BigInteger a = new BigInteger(st.nextToken());

        BigInteger x = new BigInteger(b.toString());
        int ans = 0;
        while (x.compareTo(a) <= 0) {
            String s = x.toString();
            int n = s.length();
            int cur = 0;
            while (cur < n && s.charAt(n - 1 - cur) == d) {
                ++cur;
            }
            ans = Math.max(ans, cur);
            x = x.add(b);
        }

        System.out.println(ans);
    }
}
