#include <bits/stdc++.h>

using namespace std;

#define all(x) begin(x), end(x)

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;

constexpr int MAXN = 100;
constexpr int TRIALS = 1e7;
int x[MAXN], y[MAXN];
int p[MAXN];
int order[MAXN];

int main() {
    int w, h, n;
    scanf(" %d %d %d", &w, &h, &n);

    for (int i = 0; i < n; ++i) {
        scanf(" %d %d", &x[i], &y[i]);
    }

    for (int i = 0; i < n; ++i) {
        scanf(" %d", &p[i]);
        --p[i];
    }

    int hits = 0;
    for (int round = 0; round < TRIALS; ++round) {
        double px = static_cast<double>(rand()) / RAND_MAX * w;
        double py = static_cast<double>(rand()) / RAND_MAX * h;

        iota(order, order + n, 0);
        sort(order, order + n, [&](int a, int b) {
            double dx1 = x[a] - px;
            double dy1 = y[a] - py;
            double dx2 = x[b] - px;
            double dy2 = y[b] - py;

            return dx1 * dy2 < dx2 * dy1;
        });

        bool valid = true;
        for (int i = 0; valid and i < n; ++i) {
            valid &= order[i] == p[i];
        }
        hits += valid;
    }

    cout << (1.0 * hits / TRIALS * w * h) << '\n';

    return 0;
}
