#include "testlib.h"
#include <iostream>
#include <vector>
#include <deque>

using namespace std;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int InputLength = atoi(argv[1]);
    int Answer = atoi(argv[2]);
    int MaxStep = atoi(argv[3]);

    string CH = "ACTG";

    ensuref(Answer <= InputLength, "expected answer must not be larger then input");
    deque<char> S;
    for (int i = 0; i < Answer; ++i) S.push_back(CH[rnd.next(0, 3)]);

    while (S.size() != InputLength) {
        int direction = rnd.next(0, 1);
        int stepLength = rnd.next(1, min(InputLength - int(S.size()), min(MaxStep, int(S.size()))));
        if (direction == 0) {
            for (int i = 0; i < stepLength; ++i) S.push_front(S[2*i]);
        } else {
            for (int i = 0; i < stepLength; ++i) S.push_back(S[S.size()-2*i-1]);
        }
    }

    while (!S.empty()) {
        cout << S.front();
        S.pop_front();
    }
    cout << endl;
}
