#include <iostream>
#include <vector>
#include <string>

using namespace std;

int main() {
    string S; cin >> S;
    int N = S.size();
    vector<vector<bool>> P(N+1, vector<bool>(N, false));
    for (int i = 0; i < N; ++i) {
        P[0][i] = P[1][i] = true;
    }

    for (int l = 2; l <= N; ++l) {
        for (int i = 0; i + l <= N; ++i) {
            P[l][i] = P[l-2][i+1] && (S[i] == S[i+l-1]);
        }
    }

    vector<vector<int>> A(N+1);
    for (int i = 0; i <= N; ++i) A[i] = vector<int>(N, i);
    for (int l = 2; l <= N; ++l) {
        for (int i = 0; i + l <= N; ++i) {
            for (int j = 2; j <= l; j += 2) {
                if (P[j][i]) A[l][i] = min(A[l][i], A[l-j/2][i+j/2]);
                if (P[j][i+l-j]) A[l][i] = min(A[l][i], A[l-j/2][i]);
            }
        }
    }
    
    /*
    for (int i = 0; i <= N; ++i) {
        for (int j = 0; j < N; ++j) {
            cout << P[i][j];
        }
        cout << endl;
    }

    for (int i = 0; i <= N; ++i) {
        for (int j = 0; j < N; ++j) {
            cout << A[i][j] << ' ';
        }
        cout << endl;
    }
    */

    cout << A[N][0] << endl;
}
