#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <utility>
#include <algorithm>
#include <cassert>
#include <queue>
using namespace std;

typedef long double ld;
typedef long long ll;

#define MAX 4000000

char str1[MAX + 2];
char str2[MAX + 2];

int N;
int pallen[MAX + 2];
int j;

int fold_phase(char *s) {
  j = 0;
  pallen[0] = 0;
  int beg = 0;
  for (int i = 1; i <= N; i++) {  // i is between i-1 and i
    int pos = i;
    if (j + pallen[j] > i) {
      if (i + pallen[2 * j - i - 1] < j + pallen[j]) {
        pallen[i] = pallen[2 * j - i - 1];
        continue;
      } else {
        pos = j + pallen[j];
      }
    }
    while (true) {
      if (2 * i - pos - 1 < beg) {
        pallen[i] = 0;
        j = i;
        beg = i;
        break;
      }
      if (pos >= N) {
        return beg;
      }
      if (s[pos] != s[2 * i - pos - 1]) {
        pallen[i] = pos - i;
        break;
      }
      pos += 1;
    }
  }
  assert(false);
  return -1;
}

int main() {
  scanf("%s", str1);
  N = strlen(str1);
  int beg = fold_phase(str1);
  int i = N - 1;
  N = 0;
  for (; i >= beg; i--) {
    str2[N++] = str1[i];
  }
  beg = fold_phase(str2);
  printf("%d\n", N - beg);
  return 0;
}
