#pragma GCC optimize("O3")
#pragma GCC target("arch=corei7-avx")
#include <cstdio>
#include <cstring>

char S[1<<22], Srev[1<<22];

int main(void) {
    scanf("%s", S);
    int N = strlen(S);
    for (int i = 0; i < N; ++i)
        Srev[N-1-i] = S[i];
    
    auto is_palin = [&](int l, int r) -> bool {
        return memcmp(S + l, Srev + (N-r), (r-l)/2) == 0;
    };

    int l = 0, r = N, i = 1;
    while (i <= (r-l)/2) {
        if (is_palin(l, l+2*i)) {
            l += i;
            i = 1;
        } else if (is_palin(r-2*i, r)) {
            r -= i;
            i = 1;
        } else {
            ++i;
        }
    }
    printf("%d\n", r-l);
}
