#pragma GCC optimize("O3")
#pragma GCC target("arch=corei7-avx")
#include <cstdio>
#include <cstring>

char S[1<<22], Srev[1<<22];
char Bforw[4][1<<20], Brev[4][1<<20];

int main(void) {
    int val[256];
    val['A'] = 0; val['C'] = 1; val['G'] = 2; val['T'] = 3;
    scanf("%s", S);
    int N = strlen(S);
    for (int i = 0; i < N; ++i)
        Srev[N-1-i] = S[i];
    
    memset(Bforw, 0, sizeof(Bforw));
    memset(Brev, 0, sizeof(Brev));
    for (int s = 0; s < 4; ++s) {
        for (int i = 0; i+s < N; ++i) {
            Bforw[s][i/4] |= val[S[s+i]] << 2*(i%4);
            Brev[s][i/4] |= val[S[N-1-(s+i)]] << 2*(i%4);
        }
    }
    
    auto is_palin = [&](int l, int r) -> bool {
        if (r-l <= 16) return memcmp(S + l, Srev + (N-r), (r-l)/2) == 0;
        return memcmp(Bforw[l%4] + l/4, Brev[(N-r)%4] + (N-r)/4, (r-l+7)/8) == 0;
    };

    int l = 0, r = N, i = 1;
    while (i <= (r-l)/2) {
        if (is_palin(l, l+2*i)) {
            l += i;
            i = 1;
        } else if (is_palin(r-2*i, r)) {
            r -= i;
            i = 1;
        } else {
            ++i;
        }
    }
    printf("%d\n", r-l);
}
