// TODO: check whether the edges of the line are included

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pnt = complex<ll>;

static ll dot(const pnt &a, const pnt &b)
{
    return real(conj(a) * b);
}

static ll len2(const pnt &a)
{
    return dot(a, a);
}

static ll cross(const pnt &a, const pnt &b)
{
    return imag(conj(a) * b);
}

static ll cross(const pnt &a, const pnt &b, const pnt &c)
{
    return cross(b - a, c - a);
}

int main()
{
    ios::sync_with_stdio(false);
    int N;
    ll T;
    cin >> N >> T;
    __int128 T2 = T * T;
    vector<pnt> pnts;
    for (int i = 0; i < N; i++)
    {
        int x, y;
        cin >> x >> y;
        pnts.emplace_back(x, y);
    }

    int ans = 2;
    for (int i = 0; i < N; i++)
        for (int j = 0; j < N; j++)
        {
            if (i == j)
                continue;
            int inside = 0;
            __int128 limit = T2 * len2(pnts[j] - pnts[i]);
            for (int k = 0; k < N; k++)
            {
                ll area = cross(pnts[i], pnts[j], pnts[k]);
                __int128 area2 = __int128(area) * area;
                if (area >= 0 && area2 <= limit)
                    inside++;
            }
            ans = max(ans, inside);
        }
    cout << ans << '\n';
    return 0;
}
