// TODO: suggest reducing x, y, z limits to 10^9 to prevent overflows.

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main()
{
    ios::sync_with_stdio(false);
    int N;
    cin >> N;
    ll mx[8] = {};
    vector<array<ll, 3>> phones(N);
    for (int i = 0; i < N; i++)
    {
        for (int j = 0; j < 3; j++)
            cin >> phones[i][j];
        for (int j = 0; j < 8; j++)
        {
            ll sum = 0;
            for (int k = 0; k < 3; k++)
                if (j & (1 << k))
                    sum += phones[i][k];
            mx[j] = max(mx[j], sum);
        }
    }

    ll best = LLONG_MAX;
    int besti = 0;
    for (int i = 0; i < N; i++)
    {
        array<ll, 8> sums = {};
        for (int j = 0; j < 8; j++)
            for (int k = 0; k < 3; k++)
                if (j & (1 << k))
                    sums[j] += phones[i][k];
        ll cost = LLONG_MIN;
        for (int j = 0; j < 8; j++)
        {
            ll score = sums[7 ^ j] + mx[j] - sums[7];
            cost = max(cost, score);
        }
        if (cost < best)
        {
            best = cost;
            besti = i;
        }
    }
    cout << best << ' ' << besti + 1 << '\n';
    return 0;
}
