#!/usr/bin/env python3
# Assumes data formatting has been checked by formatting.ctd

import sys

b = int(sys.stdin.readline())
for batch in range(b):
    print('Checking batch', batch + 1)
    n, state = sys.stdin.readline().split()
    n = int(n)
    ones = len([c for c in state if c == '1'])
    if ones * 2 <= n:
        print('More than half the machines must be good')
        sys.exit(1)
    for i in range(n):
        line = sys.stdin.readline().strip()
        if state[i] == '1' and line != state:
            print('Machine {} is marked good but does not match state'.format(i + 1))
            sys.exit(1)

sys.exit(42)
