#include <stdio.h>
#include <stdlib.h>

#define MAXN 2001
int n, v, c;

struct quest {
    int xp, target, deadline;
} quests[MAXN];

typedef struct quest quest;

int cmp(const void* a, const void* b) {
    return ((const quest*) a)->deadline - ((const quest*) b)->deadline;
}

char dp[MAXN * MAXN];

#define min(a, b) (a < b ? a : b)
#define max(a, b) (a > b ? a : b)

int main(int argc, char** argv) {
    scanf(" %d %d %d", &n, &v, &c);
    int total = 0;
    for (int i = 0; i < n; ++i) {
        scanf(" %d %d", &quests[i].xp, &quests[i].target);
        quests[i].deadline = quests[i].xp * c + quests[i].target * v;
        total += quests[i].xp;
    }

    qsort(quests, n, sizeof(quest), cmp);
    int ans = 0;
    dp[0] = 1;
    for (int i = 0; i < n; i++) {
        int start = min((v * quests[i].target + c - 1) / c - 1, total - quests[i].xp);
        for (int j = start; j >= 0; --j) {
            if (dp[j]) {
                dp[j + quests[i].xp] = 1;
                ans = max(ans, j + quests[i].xp);
            }
        }
    }

    ans = total + (c - 1) * ans;
    printf("%d\n", ans);
}
