#include <cstdio>
#include <cstdlib>
#include <cstdint>
#include <vector>
#include <utility>
#include <algorithm>
#include <cassert>
#include <queue>
using namespace std;

typedef uint64_t ll;

#define ARRS (4001000 / 64)

unsigned int N, C, V;
ll reach[ARRS];
typedef struct quest {
  unsigned int X;
  unsigned int D;
} quest;
bool operator<(const quest &A, const quest &B) {
  return A.D * V + A.X * C < B.D * V + B.X * C;
}
quest quests[2200];

int main() {
  scanf("%u %u %u\n", &N, &V, &C);
  int total = 0;
  for (unsigned int i = 0; i < N; ++i) {
    scanf("%u %u", &quests[i].X, &quests[i].D);
    total += quests[i].X;
  }
  sort(&quests[0], &quests[N]);
  for (unsigned int i = 0; i < ARRS; ++i) reach[i] = 0LL;
  reach[0] = 1LL;
  int top = 0;
  for (unsigned int i = 0; i < N; ++i) {
    int P = quests[i].X;
    int P64 = P / 64;
    int P63 = P & 63;
    int r = (V * quests[i].D - 1) / C;
    if (r > top) r = top + 1;
    top += P;
    // First, let's get to an even number - 1.
    for (; (r & 63) != 63; r--) {
      if (reach[r / 64] & (1ULL << (r & 63))) {
        reach[(r+P) / 64] |= (1ULL << ((r + P) & 63));
      }
    }
    for (; r >= 0; r -= 64) {
      ll v;
      if (P63) {
        v = reach[r / 64] >> (64 - P63);
        reach[(r / 64) + P64 + 1] |= v;
      }
      v = reach[r / 64] << P63;
      reach[(r / 64) + P64] |= v;
    }
  }
  int best = 0;
  for (int r = 0; r < ARRS * 64; ++r) {
    if (reach[r / 64] & (1ULL << (r & 63))) best = r;
  }
  printf("%d\n", best * (C - 1) + total);
  return 0;
}
