#include <bits/stdc++.h>

using namespace std;

using pii = pair<int, int>;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, v, c;
    cin >> n >> v >> c;

    vector<pii> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }

    sort(begin(a), end(a));

    int ans = 0;
    do {
        int xp = 0;

        for (auto& level : a) {
            int x, d;
            tie(x, d) = level;

            int cur_level = xp / v;
            if (cur_level < d) {
                xp += c * x;
            } else {
                xp += x;
            }
        }

        ans = max(ans, xp);
    } while (next_permutation(begin(a), end(a)));

    cout << ans << '\n';

    return 0;
}
