#include <algorithm>
#include <iostream>
#include <vector>
using namespace std;

int main() {
  int N, V, C;
  while (cin >> N >> V >> C) {
    vector<pair<int, int>> DX(N);
    for (auto& [d, x] : DX) cin >> x >> d;

    vector<int> dyn(N * 2000 + 2001, -1);
    dyn[0] = 0;
    int totx = 0;
    sort(DX.begin(), DX.end());
    for (auto [d, x] : DX) {
      int lim = (d*V-1)/C;
      for (int i = totx; i > lim; i--) if (dyn[i] >= x) dyn[i+x] = max(dyn[i+x], dyn[i]-x);
      for (int i = min(lim, totx); i >= 0; i--) if (dyn[i] >= 0) dyn[i+x] = max(dyn[i+x], lim-i);
      totx += x;
    }

    int64_t ret = 0;
    for (auto [_, x] : DX) ret += x;
    for (int64_t i = totx; ; i--) if (dyn[i] >= 0) {
      ret += i * (C-1);
      break;
    }

    cout << ret << endl;
  }
}
