import java.util.*;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

/****
#include <bits/stdc++.h>
  
using namespace std;

struct record
{
    int total = 0;
    int child = -1;
};
****/

class record {
    public int total;
    public int child;
    public record() {
      total = 0;
      child = -1;
    }
    public record(int t, int c) {
      total = t; child = c;
    }
}

//typedef array<record, 4> records; I.e., records r <==> record[4]
/****
struct node
{
    int max_path = 0;     // longest path in the subtree
    int max_path_up = 0;  // two paths, one of which ends at the root
    int height = 0;       // max path length in subtree starting at this node
    int full = 0;         // two paths in subtree
    vector<pair<int, int>> edges;
};
****/

class Pair {
  public int first,second;
  public Pair(int v, int d) {
    first = v; second = d;
  }
}

class node {
    public int max_path;     // longest path in the subtree
    public int max_path_up;  // two paths, one of which ends at the root
    public int height;  // max path length in subtree starting at this node
    public int full;         // two paths in subtree
    public Vector<Pair> edges = new Vector<Pair>();
    public node() {
      max_path = 0; max_path_up = 0; height = 0; full = 0;
      edges = new Vector<Pair>();
    }
}


public class MerrySnowTranslate {

/****
static void push(records &r, const record &n)
{
    for (int i = 0; i < int(r.length); i++)
    {
        if (n.total >= r[i].total)
        {
            for (int j = r.length - 1; j > i; j--)
                r[j] = r[j - 1];
            r[i] = n;
            return;
        }
    }
}
****/

//static vector<node> nodes;

  public static node[] nodes;

  public static void push (record[] r, record n) {
    for (int i = 0; i < r.length; i++)
    {
        if (n.total >= r[i].total)
        {
            for (int j = r.length - 1; j > i; j--)
                r[j] = r[j - 1];
            r[i] = n;
            return;
        }
    }
  }


/****
static void recurse(int cur, int parent)
{
    node n = nodes[cur];
    records path, path_up, height;
    for (const auto &edge : n.edges)
    {
        int y = edge.first;
        int d = edge.second;
        if (y == parent)
            continue;
        recurse(y, cur);
        int h = nodes[y].height + d;
        push(height, record{h, y});
        push(path, record{nodes[y].max_path, y});
        push(path_up, record{nodes[y].max_path_up + d, y});
        n.full = Math.max(n.full, nodes[y].full);
    }
    n.height = height[0].total;
    n.max_path = max(path[0].total, height[0].total + height[1].total);
    // Two paths, one ending at the root. Either the second path is in the same
    // subtree that the first path descends to, or they're unrelated.
    //
    n.max_path_up = path_up[0].total;
    for (int i = 0; i < 2; i++)
        for (int j = 0; j < 2; j++)
            if (height[i].child == -1 || path[j].child != height[i].child)
            {
                int score = height[i].total + path[j].total;
                n.max_path_up = max(n.max_path_up, score);
            }
    n.max_path_up = max(n.max_path_up, height[0].total + height[1].total + height[2].total);

    // A pair of maximal paths in this subtree consists of either:
    // - Two paths in the same subtree (handled in the loop above).
    // - One path in each of two separate subtrees.
    // - Both paths pass though the root
    // - One passing through the root and visiting the subtree of the other.
    // - One passing through the root, but not visiting the subtree of the other.
     //
    n.full = max(n.full, n.max_path_up);
    n.full = max(n.full, path[0].total + path[1].total);
    n.full = max(n.full, height[0].total + height[1].total + height[2].total + height[3].total);
    for (int i = 0; i < 2; i++)
        for (int j = 0; j < 2; j++)
            if (height[i].child == -1 || path_up[j].child != height[i].child)
            {
                int score = height[i].total + path_up[j].total;
                n.full = max(n.full, score);
            }
    for (int i = 0; i < 3; i++)
        for (int j = i + 1; j < 3; j++)
            for (int k = 0; k < 3; k++)
                if (path[k].child == -1
                    || (path[k].child != height[i].child && path[k].child != height[j].child))
                {
                    int score = height[i].total + height[j].total + path[k].total;
                    n.full = max(n.full, score);
                }
}
****/
  public static void recurse(int cur, int parent)
  {
    node n = nodes[cur];
    record[] path, path_up, height;
    path = new record[4]; path_up = new record[4]; height = new record[4];
    for (int i = 0; i < 4; i++) {
      path[i] = new record(); path_up[i] = new record(); height[i] = new record();
    }
    for ( Pair edge : n.edges)
    {
        int y = edge.first;
        int d = edge.second;
        if (y == parent)
            continue;
        recurse(y, cur);
        int h = nodes[y].height + d;

        push(height, new record(h, y));
        push(path, new record(nodes[y].max_path, y));
        push(path_up, new record(nodes[y].max_path_up + d, y));
        n.full = Math.max(n.full, nodes[y].full);
    }
    n.height = height[0].total;
    n.max_path = Math.max(path[0].total, height[0].total + height[1].total);
    // Two paths, one ending at the root. Either the second path is in the same
    // subtree that the first path descends to, or they're unrelated.
    //
    n.max_path_up = path_up[0].total;
    for (int i = 0; i < 2; i++)
        for (int j = 0; j < 2; j++)
            if (height[i].child == -1 || path[j].child != height[i].child)
            {
                int score = height[i].total + path[j].total;
                n.max_path_up = Math.max(n.max_path_up, score);
            }
    n.max_path_up = Math.max(n.max_path_up, height[0].total + height[1].total + height[2].total);

    // A pair of maximal paths in this subtree consists of either:
    // - Two paths in the same subtree (handled in the loop above).
    // - One path in each of two separate subtrees.
    // - Both paths pass though the root
    // - One passing through the root and visiting the subtree of the other.
    // - One passing through the root, but not visiting the subtree of the other.
    //
    n.full = Math.max(n.full, n.max_path_up);
    n.full = Math.max(n.full, path[0].total + path[1].total);
    n.full = Math.max(n.full, height[0].total + height[1].total + height[2].total + height[3].total);
    for (int i = 0; i < 2; i++)
        for (int j = 0; j < 2; j++)
            if (height[i].child == -1 || path_up[j].child != height[i].child)
            {
                int score = height[i].total + path_up[j].total;
                n.full = Math.max(n.full, score);
            }
    for (int i = 0; i < 3; i++)
        for (int j = i + 1; j < 3; j++)
            for (int k = 0; k < 3; k++)
                if (path[k].child == -1
                    || (path[k].child != height[i].child && path[k].child != height[j].child))
                {
                    int score = height[i].total + height[j].total + path[k].total;
                    n.full = Math.max(n.full, score);
                }
}
/****
int main()
{
    int N;
    cin >> N;
    nodes.resize(N);
    int tdist = 0;
    for (int i = 0; i < N - 1; i++)
    {
        int u, v, d;
        cin >> u >> v >> d;
        u--;
        v--;
        nodes[u].edges.emplace_back(v, d);
        nodes[v].edges.emplace_back(u, d);
        tdist += d;
    }
    recurse(0, -1);
    int ans = 2 * tdist - nodes[0].full;
    cout << ans <<'\n';

    return 0;
}
****/
  public static void main(String[] args) throws IOException {
    BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
    StringTokenizer st;
    int N;
    N = Integer.parseInt(in.readLine());
    nodes = new node[N];
    for (int i = 0; i < N; i++) nodes[i] = new node();
    int tdist = 0;
    for (int i = 0; i < N - 1; i++)
    {
        int u, v, d;
        st = new StringTokenizer(in.readLine());
        u = Integer.parseInt(st.nextToken());
        v = Integer.parseInt(st.nextToken());
        d = Integer.parseInt(st.nextToken());
        u--;
        v--;
        nodes[u].edges.add(new Pair(v, d));
        nodes[v].edges.add(new Pair(u, d));
        tdist += d;
    }
    recurse(0, -1);
    int ans = 2 * tdist - nodes[0].full;
    System.out.println(ans);
  }
}
