// THIS NEEDS CLEANED UP SINCE IT'S JUST BEEN A SLOW ACCRETION OF TINY FIXES
// THAT FORM ONE INCOMPREHENSIBLE WHOLE. COMMENTS ARE PROBABLY NO LONGER
// VALID SINCE CODE HAS CHANGED WITHOUT CORRESPONDING UPDATES IN DOCUMENTATION.

import java.util.*;

class Edge {
  public int from,to;
  public int dist;
  public Edge(int f, int t, int d) {
    from = f; to = t; dist = d;
  }
}

class Vertex {
  public int id,parent;
  public int loop,min1,min2,min3,min4;
  public ArrayList<Edge> nbr;
  public Vertex(int i) {
    id = i;
    nbr = new ArrayList<Edge>();
  }
}

public class RSRSnow2 {
  public static Scanner in = new Scanner(System.in);
  public static int n;
  public static Vertex[] gr;
  public static int min;

  public static void main(String[] args) {
    in = new Scanner(System.in);
    n = in.nextInt();
    gr = new Vertex[n];
    for (int i = 0; i < n-1; i++) {
      int v = in.nextInt()-1;
      int w = in.nextInt()-1;
      int d = in.nextInt();
      if (gr[v]==null) {
        gr[v] = new Vertex(v);
      }
      if (gr[w]==null) {
        gr[w] = new Vertex(w);
      }
      gr[v].nbr.add(new Edge(v,w,d));
      gr[w].nbr.add(new Edge(w,v,d));
    }

    min = Integer.MAX_VALUE;

    gr[0].parent = -1;
    dfs(0,"");

    System.out.println(gr[0].min4);
  }


  public static void dfs(int v, String ind) {

    int numch = gr[v].nbr.size()-1;
    if (gr[v].parent < 0) numch++;

    // Is this a leaf? If so, all values are zero:
    if (numch == 0) {
      gr[v].loop = gr[v].min1 = gr[v].min2 = gr[v].min3 = gr[v].min4 = 0;

      return;
    }

    int min1 = Integer.MAX_VALUE;
    int min2 = Integer.MAX_VALUE;
    int min3 = Integer.MAX_VALUE;
    int min4 = Integer.MAX_VALUE;
    int loop = 0;

    int sumloop = 0; // 2*sum of all subtree weights
    int sumdist = 0; // sum of all edge weights except parent

// When I was just working with one set of gain values this wasn't bad.
// Now it's horrible.

    int gain1, gain2, gain3, gain4; // Four biggest "gain" values for min1
    gain1 = gain2 = gain3 = gain4 = 0;

    int x1,x2,x3,x4; // children corresponding to four biggest gains
    x1 = x2 = x3 = x4 = -1;

    Edge e1, e2, e3, e4; // edges corresponding to four biggest gains
    e1 = e2 = e3 = e4 = null;

    int min2gain1, min2gain2, min2gain3; // Three biggest gains for min2
    min2gain1 = min2gain2 = min2gain3 = 0;

    int min2x1, min2x2, min2x3;
    min2x1 = min2x2 = min2x3 = -1;

    Edge min2e1, min2e2, min2e3;
    min2e1 = min2e2 = min2e3 = null;

    int min3gain1 = 0,min3gain2 = 0; // Two biggest gaines for min3
    int min3x1 = -1, min3x2 = -1;
    Edge min3e1 = null, min3e2 = null;

    int min4gain1 = 0,min4gain2 = 0;
    int min4x1 = -1, min4x2 = -1;
    Edge min4e1 = null, min4e2 = null;

///////
/// First pass: gather info about max gain, loop sums:
///////

    for (Edge e:gr[v].nbr) {
      int w = e.to;
      if (w == gr[v].parent) continue;
      gr[w].parent = v;
      sumdist += e.dist;
      dfs(w,ind+"   ");
      sumloop += gr[w].loop;

      // For each child of v, see how much we can improve minimum by adding
      // a second path branching off from a shortest path thru v:

      int gain = gr[w].loop - gr[w].min1 + e.dist; // best new branch?

// Lots of copy and paste here--needs lots of cleanup:

      if (gain > gain1) {
        x4 = x3; x3 = x2; x2 = x1; x1 = w; 
        e4 = e3; e3 = e2; e2 = e1; e1 = e;
        gain4 = gain3; gain3=gain2; gain2 = gain1; gain1 = gain;
      } else if (gain == gain1 || gain > gain2) {
        x4 = x3; x3 = x2; x2 = w; 
        e4 = e3; e3 = e2; e2 = e;
        gain4 = gain3; gain3=gain2; gain2 = gain;
      } else if (gain == gain2 || gain > gain3) {
        x4 = x3; x3 = w; gain4 = gain3; gain3 = gain;
        e4 = e3; e3 = e;
      } else if (gain == gain3 || gain > gain4) {
        x4 = w;
        e4 = e;
        gain4 = gain;
      }

      gain = gr[w].loop - gr[w].min2 + e.dist;
      if (gain > min2gain1) {
        min2x3 = min2x2; min2x2 = min2x1; min2x1 = w;
        min2e3 = min2e2; min2e2 = min2e1; min2e1 = e;
        min2gain3 = min2gain2; min2gain2 = min2gain1; min2gain1 = gain;
      } else if (gain == min2gain1 || gain > min2gain2) {
        min2x3 = min2x2; min2x2 = w;
        min2e3 = min2e2; min2e2 = e;
        min2gain3 = min2gain2; min2gain2 = gain;
      } else if (gain == min2gain2 || gain > min2gain3) {
        min2x3 = w;
        min2e3 = e;
        min2gain3 = gain;
      }

      gain = gr[w].loop - gr[w].min3 + e.dist;
      if (gain > min3gain1) {
        min3x2 = min3x1; min3x1 = w;
        min3e2 = min3e1; min3e1 = e;
        min3gain2 = min3gain1; min3gain1 = gain;
      } else if (gain == min3gain1 || gain > min3gain2) {
        min3x2 = w; min3e2 = e; min3gain2 = gain;
      }

      gain = gr[w].loop - gr[w].min4;
      if (gain > min4gain1) {
        min4x2 = min4x1; min4x1 = w;
        min4e2 = min4e1; min4e1 = e;
        min4gain2 = min4gain1; min4gain1 = gain;
      } else if (gain == min4gain1 || gain > min4gain2) {
        min4x2 = w; min4e2 = e; min4gain2 = gain;
      }
    }

    int all = sumloop + 2*sumdist;

////////
/// (1) Update shortest path THRU v (i.e., v internal to path) through w.
///     Uses "gain" info just collected.
////////

    if (numch == 1) { // only one child, reached via e1
      min2 = 2*e1.dist + gr[x1].min2; // "splice" into shortest path thru child


    } else { // otherwise, endpoints are in the 2 trees with max min1 gain:
      // sanity check:
      min2 = all - gain1 - gain2;
    }

////////
/// (2) Update shortest path ENDING at v (i.e., one endpoint at v, other in
///     some subtree of v). Use edge with biggest min1 gain
////////

    min1 = all - gain1;


/////////
/// (4) Update min3 values:
/////////


    if (numch >= 3) { // both paths go thru v
      min3 = all - gain1 - gain2 - gain3;
    } else {
      min3 = all - min2gain1; // just one path goes thru v
      min3 = Math.min(min3,all - min3gain1); // just one path goes thru v
    }


   if (numch >= 1) {
     min3 = Math.min(min3,all-min3gain1);
   }



    if (numch >= 2) {

      // find best combination of a path ending at v and a spliced path thru v
      if (x1 != min2x1) {
      min3 = Math.min(min3,all - gain1 - min2gain1 + min2e2.dist);
      } else {
      min3 = Math.min(min3,all - gain1 - min2gain2 + min2e2.dist);
      min3 = Math.min(min3,all - gain2 - min2gain1 + min2e1.dist);
      }
    }


/////////
/// (5) Update min4 values:
/////////
    if (numch == 1) {
      min4 = Math.min(min4,all - min4gain1);
    } else {
      if (numch >= 4) {
        min4 = Math.min(min4,all - gain1 -gain2 - gain3 - gain4);
      }
      if (x1 != min2x1) {
        min4 = Math.min(min4,all - gain1 - min2gain1);
      } else {
        min4 = Math.min(min4,all-gain1-min2gain2);
        min4 = Math.min(min4,all-gain2-min2gain1);
      }
    }
    if (numch >= 2) {
      min4 = Math.min(min4, all - min2gain1 - min2gain2+min2e1.dist +min2e2.dist);


      if (x1 != min3x1) {
        min4 = Math.min(min4,all-gain1-min3gain1);
      } else {
        min4 = Math.min(min4,all-gain1-min3gain2);
        min4 = Math.min(min4,all-gain2-min3gain1);
      }
    }

    if (numch >= 3) {
      int g1[] = {gain1,gain2,gain3};
      Edge edg1[] = {e1,e2,e3};
      int g2[] = {min2gain1-min2e1.dist,min2gain2-min2e2.dist,min2gain3-min2e3.dist};
      Edge edg2[] = {min2e1,min2e2,min2e3};
      for (int i = 0; i < 3; i++) {
        for (int j = 0; j < 3; j++) {
          for (int k = 0; k < 3; k++) {
            if (i==j) continue;
            if (edg1[i].to == edg2[k].to || edg1[j].to == edg2[k].to) continue;
            min4 = Math.min(min4,all-g1[i]-g1[j] - g2[k]);
          }
        }
      }
    }


    min3 = Math.min(min3,min2);
    min4 = Math.min(min4,min3);

    gr[v].min1 = min1;
    gr[v].min2 = min2;
    gr[v].min3 = min3;
    gr[v].min4 = min4;
    gr[v].loop = all;
  }
}
