
/* This script generates the illustration figure (no data needed). */

//settings.prc = false;
size(5cm,0);
import three;

draw(-0.6X -- 10X, linewidth(0.2pt), arrow=Arrow3(TeXHead2), L=Label(scale(0.3)*"$x$", position=EndPoint, linewidth(0.5)));
draw(-0.6Y -- 10Y, linewidth(0.2pt), arrow=Arrow3(TeXHead2), L=Label(scale(0.3)*"$y$", position=EndPoint));
draw(-0.6Z -- 25Z, linewidth(0.2pt), arrow=Arrow3(TeXHead2,2), L=Label(scale(0.8)*"$z$", position=EndPoint));

void onecube(int x1, int y1, int z1, int x2, int y2, int z2) {
	for (int x = x1; x < x2; ++x)
	for (int y = y1; y < y2; ++y)
	for (int z = z1; z < z2; ++z) {
		draw(box((x,y,z), (x+1,y+1,z+1)),blue+linewidth(0.3pt));
		draw(shift(x,y,z) * unitcube, lightgray);
	}
}

onecube(1,1,1, 7,7,7);
onecube(0,0,0, 3,3,3);
onecube(5,0,0, 8,3,3);
onecube(0,5,0, 3,8,3);
onecube(0,0,5, 3,3,8);
onecube(5,5,0, 8,8,3);
onecube(5,0,5, 8,3,8);
onecube(0,5,5, 3,8,8);
onecube(5,5,5, 8,8,8);

//draw(box((-2,-2,-2), (11,11,11)), white+opacity(0));


draw(shift(0.5,1.5,0)*scale(0.25,0.25,0.25)*unitsphere, red, nolight);
draw((0.5,1.5,0)--(3,1.5,0)--(3,1.5,1)--(5,1.5,1)--(5,1.5,0)--(8,1.5,0)
	--(8,1.5,3)--(7,1.5,3)--(7,1.5,5)--(8,1.5,5)--(8,1.5,7.8),
	red+linewidth(1.5pt), arrow=Arrow3(9, emissive(red)));

draw(shift(3.5,5.5,1)*scale(0.25,0.25,0.25)*unitsphere, green, nolight);
draw((3.5,5.5,1)--(3.5,7,1)--(3.5,7,6.8),
	green+linewidth(1.5pt), arrow=Arrow3(8, emissive(green)));

