#!/usr/bin/env python3

# Linear tree, with another leaf hanging off edge node.

import argparse
from random import *

from speedlimit_utils import MAXS, output

parser = argparse.ArgumentParser()
parser.add_argument('n', type=int)
parser.add_argument('c', type=int)
args = parser.parse_args()
n = args.n

edges = []
m = n // 2
for i in range(1, m):
    edges.append((i - 1, i, randint(1, MAXS)))
for i in range(m, n):
    edges.append((i, i % m, randint(1, MAXS)))
output(edges, args.c)
