#!/usr/bin/env python3

# Star topology, all roads have near-maximum but unique cost

import argparse

from speedlimit_utils import MAXS, output

parser = argparse.ArgumentParser()
parser.add_argument('n', type=int)
parser.add_argument('c', type=int)
args = parser.parse_args()

edges = [(0, i, MAXS - i - 1) for i in range(1, args.n)]
output(edges, args.c)
